// sattool - visual satellite tracking and prediction tool.
// Copyright 2000 Tom Rothamel <tom-idbg@onegeek.org>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  

/* Lexer for filter expressions */

%{
#include "sattool.h"
#include "filter.h"
#include "filter_parse.h"
#include <stdlib.h>

#define yylval filter_lval 

%}

%option noyywrap

CHAR [-A-Za-z0-9.+]

%%

lt { return '<'; }
gt { return '>'; }
eq { return '='; }
=+ { return '='; }

and { return AND; }
or { return OR; }

{CHAR}+ {
	yylval.s = strdup(yytext);
	return STR;
}

[ \t\n]

. { return yytext[0]; }

%%

void filter_scan(char *s) {
	filter__scan_string(s);
}
